#!/bin/bash

# Tests hosts for SNI proxy support by trying to connect through them to www.example.com.
# Usage: torsocks ./test-sniproxy.sh HOST...

# The output format is CSV:
# host,port,sni,is_sniproxy

set -e
set -o pipefail

SNI=www.example.com

port=443
for host in "$@"; do
	is_sniproxy=$(if echo -n $'GET / HTTP/1.0\r\nHost: '"$SNI"$'\r\nConnection: close\r\n\r\n' | timeout 10 openssl s_client -ign_eof -quiet -connect $host:$port -servername "$SNI" | grep -q '<title>Example Domain</title>'; then echo "T"; else echo "F"; fi)
	echo "$host,$port,$SNI,$is_sniproxy"
done
